/*
** Jo Sega Saturn Engine
** Copyright (c) 2012-2017, Johannes Fetz (johannesfetz@gmail.com)
** All rights reserved.
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are met:
**     * Redistributions of source code must retain the above copyright
**       notice, this list of conditions and the following disclaimer.
**     * Redistributions in binary form must reproduce the above copyright
**       notice, this list of conditions and the following disclaimer in the
**       documentation and/or other materials provided with the distribution.
**     * Neither the name of the Johannes Fetz nor the
**       names of its contributors may be used to endorse or promote products
**       derived from this software without specific prior written permission.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
** ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
** DISCLAIMED. IN NO EVENT SHALL Johannes Fetz BE LIABLE FOR ANY
** DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
** (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
** LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
** ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
** SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
/** @file jo.h
 *  @author Johannes Fetz
 *
 *  @brief Jo Engine Main Header
 *  @bug No known bugs.
 */

#ifndef __JO_H__
# define __JO_H__

/*
** INCLUDES
*/
#include <stdbool.h>
#include "sgl_prototypes.h"
#include "conf.h"
#include "types.h"
#include "sega_saturn.h"
#include "time.h"
#include "smpc.h"
#include "core.h"
#include "math.h"
#include "tools.h"
#include "vdp1_command_pipeline.h"
#include "malloc.h"
#include "colors.h"
#include "list.h"
#include "input.h"
#include "fs.h"
#include "audio.h"
#include "image.h"
#include "tga.h"
#include "sprites.h"
#include "background.h"
#include "hitbox.h"
#include "sprite_animator.h"
#include "map.h"
#include "mode7.h"
#include "physics.h"
#include "3d.h"
#include "backup.h"
#include "video.h"
#include "effects.h"
#include "font.h"

#endif /* !__JO_H__ */

/*
** END OF FILE
*/
