/*
** Jo Sega Saturn Engine
** Copyright (c) 2012-2017, Johannes Fetz (johannesfetz@gmail.com)
** All rights reserved.
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are met:
**     * Redistributions of source code must retain the above copyright
**       notice, this list of conditions and the following disclaimer.
**     * Redistributions in binary form must reproduce the above copyright
**       notice, this list of conditions and the following disclaimer in the
**       documentation and/or other materials provided with the distribution.
**     * Neither the name of the Johannes Fetz nor the
**       names of its contributors may be used to endorse or promote products
**       derived from this software without specific prior written permission.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
** ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
** DISCLAIMED. IN NO EVENT SHALL Johannes Fetz BE LIABLE FOR ANY
** DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
** (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
** LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
** ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
** SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
/** @file sgl_prototypes.h
 *  @author Johannes Fetz
 *
 *  @brief SGL prototypes
 */

#ifndef __JO_SGL_PROTOTYPES_H__
# define __JO_SGL_PROTOTYPES_H__

#if !JO_COMPILE_USING_SGL

//HACK
#define SEGA_XPT_H
#define SEGA_GFS_H
#define SEGA_CDC_H
#define SEGA_BUP_H

/*
#include <sgl.h>
*/
#define	    VDP2_VRAM_A0	0x25e00000
#define	    VDP2_VRAM_A1	0x25e20000
#define	    VDP2_VRAM_B0	0x25e40000
#define	    VDP2_VRAM_B1	0x25e60000

#define	    VDP2_COLRAM    		0x25f00000
#define		CHAR_SIZE_1x1		0

#define		COL_TYPE_256		0x10

#define	    KTBL0_RAM		VDP2_VRAM_A1		/* ]XN[pWe[u */
#define	    BACK_CRAM		(KTBL0_RAM + 0x1fffe)	/* Back color */

#define	    CL_Half		2		/* Px[h */
#define	    CL_Trans		3		/* [h */
#define	    CL_Gouraud		4		/* O[[VF[fBO[h */

#define	PER_ID_NotConnect	0xff	/* ڑ				*/
#define	PER_ID_StnPad		0x02	/* T^[Wpbh			*/
#define	PER_ID_StnMouse		0x23	/* T^[}EX			*/
#define	PER_ID_ShuttleMouse	0xe3	/* Vg}EX			*/

#define	    toFIXED(a)		((FIXED)(65536.0 * (a)))
#define	    POStoFIXED(x,y,z)	{toFIXED(x),toFIXED(y),toFIXED(z)}
#define	    DEGtoANG(d)		((ANGLE)((65536.0 * (d)) / 360.0))
#define	NORMAL(x,y,z)		{POStoFIXED(x,y,z)
#define	VERTICES(v0,v1,v2,v3)	{v0 , v1 , v2 , v3}}
#define	C_RGB(r,g,b)		(((b)&0x1f)<<10|((g)&0x1f)<<5|((r)&0x1f)|0x8000)

#define	    ECdis		(1 << 7)	/* GhR[hpbĝЂƂƂĎgp */

#define	    SPdis		(1 << 6)	/* Xy[XR[hpbĝЂƂƂĎgp */

#define	    sprPolygon		(FUNC_Polygon | ((ECdis | SPdis) << 24))

#define	    FUNC_Texture	2
#define	    FUNC_Polygon	4
#define	    FUNC_PolyLine	5

#define	    MESHon		(1 << 8)	/* bVŕ\ */
#define	    CL32KRGB		(5 << 3)	/* qfaRQjF[h */

#define	    UseTexture		(1 << 2)	/* eNX`\|S */
#define	    UseLight		(1 << 3)	/* ̉e󂯂|S */
#define	    UsePalette		(1 << 5)	/* |S̃J[ */

#define	    No_Texture		0		/* eNX`gpȂ */
#define	    No_Option		0		/* IvVgpȂ */
#define	    No_Gouraud		0		/* O[[VF[fBOgpȂ */
#define	    No_Palet	        0		/* J[pbg̎w肪Ȃ */

#define	    sprNoflip		((0) | FUNC_Texture | (UseTexture << 16))

typedef unsigned char	Uint8 ;		/* ȂPoCg */
typedef signed   char	Sint8 ;		/* PoCg */
typedef unsigned short	Uint16 ;	/* ȂQoCg */
typedef signed   short	Sint16 ;	/* QoCg */
typedef unsigned long	Uint32 ;	/* ȂSoCg */
typedef signed   long	Sint32 ;	/* SoCg */
typedef int		Bool ;		/* _^i_萔lɂƂj	*/
typedef float		Float32 ;	/* SoCg */

enum ps {X, Y, Z, XYZ, XYZS, XYZSS, XY = Z, S = XYZ, Sh = S, Sv = XYZS} ;
enum base
{
    SORT_BFR,			/* Oɕ\|S̈ʒug */
    SORT_MIN,			/* S_̓AԎO̓_g */
    SORT_MAX,			/* S_̓ԉ_g */
    SORT_CEN			/* S_̕ψʒug */
} ;

enum pln
{
    Single_Plane,			/* Жʃ|S */
    Dual_Plane			/* ʃ|S(\̌ʂȂ) */
} ;

typedef	    Sint16	ANGLE ;
typedef	    Sint32	FIXED ;
typedef     FIXED	MATRIX[4][3] ;		/* }gNXf[^ */
typedef     FIXED	VECTOR[XYZ] ;		/* xNgf[^ */
typedef     FIXED	POINT[XYZ] ;		/* _̈ʒuf[^ */

#define		_Stereo		0x80
#define		_Mono		0x00

#define		_PCM16Bit	0x00
#define		_PCM8Bit	0x10

typedef struct
{
    Uint8	mode ;		/* Mode */
    Uint8	channel ;	/* PCM Channel Number */
    Uint8	level ;		/* 0 ~ 127 */
    Sint8	pan ;		/* -128 ~ +127 */
    Uint16	pitch ;
    Uint8	eflevelR ;	/* Effect level for Right(mono) 0 ~ 7 */
    Uint8	efselectR ;	/* Effect select for Right(mono) 0 ~ 15 */
    Uint8	eflevelL ;	/* Effect level for Left 0 ~ 7 */
    Uint8	efselectL ;	/* Effect select for Left 0 ~ 15 */
} PCM ;

enum SmpcCommand  			/* rlobR}hԍ			*/
{
    SMPC_MSHON,			/* (00) }X^@rgQ@nm		*/
    SMPC_SSHON,			/* (01) X[u@rgQ@nm		*/
    SMPC_SSHOFF,			/* (02) X[u@rgQ@nee	*/
    SMPC_SNDON,			/* (03) TEh@nm			*/
    SMPC_SNDOFF,			/* (04) TEh@nee		*/
    SMPC_CDON,			/* (05) bc@nm			*/
    SMPC_CDOFF,			/* (06) bc@nee			*/
    SMPC_SYSRES,			/* (07) VXeS̃Zbg		*/
    SMPC_CKC352,			/* (08) NbN`FWRTQ[h	*/
    SMPC_CKC320,			/* (09) NbN`FWRQO[h	*/
    SMPC_NMIREQ,			/* (0a) mlhNGXg		*/
    SMPC_RESENA,			/* (0b) ZbgCl[u		*/
    SMPC_RESDIS,			/* (0c) ZbgfBXG[u		*/
    SMPC_GETSTS,			/* (0d) Xe[^X擾			*/
    SMPC_GETPER,			/* (0e) ytF擾		*/
    SMPC_SETMEM,			/* (0f) rlobݒ		*/
    SMPC_SETTIM,			/* (10) ݒ			*/
    SMPC_CMDMAX			/* (11) R}hԍől		*/
};

enum SmpcWaitMode  			/* rlobR}hs[h		*/
{
    SMPC_NO_WAIT,			/* (00) R}hsI҂	*/
    SMPC_WAIT			/* (01) R}hsI҂L	*/
};


enum BooleanSwitch  			/* _萔QiXCb`j */
{
    OFF = 0,
    ON  = 1
};

typedef struct
{
    Uint16	 texno ;		/* eNX`ԍ */
    Uint16	 atrb ;			/* Agr[gf[^(\[h) */
    Uint16	 colno ;		/* J[io[ */
    Uint16	 gstb ;			/* O[[VF[fBOe[u */
    Uint16	 dir ;			/* eNX`̔]ƃt@NVio[ */
} SPR_ATTR ;

typedef struct
{
    Uint8	 flag ;			/* Жʂʂ̃tO */
    Uint8	 sort ;			/* \[g̊ʒuƃIvVݒ */
    Uint16	 texno ;		/* eNX`ԍ */
    Uint16	 atrb ;			/* Agr[gf[^(\[h) */
    Uint16	 colno ;		/* J[io[ */
    Uint16	 gstb ;			/* O[[VF[fBOe[u */
    Uint16	 dir ;			/* eNX`̔]ƃt@NVio[ */
} ATTR ;

typedef struct
{
    VECTOR	 norm ;			/* @xNg */
    Uint16	 Vertices[4] ;		/* |S\钸_ԍ */
} POLYGON ;

typedef struct
{
    POINT	*pntbl ;		/* _̈ʒuf[^e[u */
    Uint32	 nbPoint ;		/* _̐ */
    POLYGON	*pltbl ;		/* |S`e[u */
    Uint32	 nbPolygon ;		/* |S̐ */
    ATTR	*attbl ;		/* |S̃Agr[ge[u */
} PDATA ;

typedef struct
{
    Uint16	 Hsize ;		/* XvCĝgTCY */
    Uint16	 Vsize ;		/* XvCĝuTCY */
    Uint16	 CGadr ;		/* XvCgbfAhX / W */
    Uint16	 HVsize ;		/* gTCY/WAuTCY(n[hp) */
} TEXTURE ;

typedef struct
{
    Uint16	 texno ;		/* eNX`ԍ */
    Uint16	 cmode ;		/* J[[h */
    void	*pcsrc ;		/* f[^̏ */
} PICTURE ;

typedef struct  			/* fW^foCX			*/
{
    Uint8	id;			/* ytFhc			*/
    Uint8	ext;			/* gf[^TCY			*/
    Uint16	data;			/* {^݃f[^			*/
    Uint16	push;			/* {^f[^			*/
    Uint16	pull;			/* {^f[^			*/
    Uint32	dummy2[4];		/* _~[Q				*/
} PerDigital;

enum BooleanLogic  			/* _萔PiUA^j */
{
    FALSE = 0,
    TRUE  = 1
};

enum tvsz
{
    TV_320x224, TV_320x240, TV_320x256, TV_dummy1,
    TV_352x224, TV_352x240, TV_352x256, TV_dummy2,
    TV_640x224, TV_640x240, TV_640x256, TV_dummy3,
    TV_704x224, TV_704x240, TV_704x256, TV_dummy4,

    TV_320x448, TV_320x480, TV_320x512, TV_dummy5,
    TV_352x448, TV_352x480, TV_352x512, TV_dummy6,
    TV_640x448, TV_640x480, TV_640x512, TV_dummy7,
    TV_704x448, TV_704x480, TV_704x512, TV_dummy8
} ;

#define		PNB_2WORD		0
#define		PNB_1WORD		0x8000
#define		CN_10BIT       		0
#define		CN_12BIT		0x4000
#define		COL_TYPE_32768		0x30

#define		PL_SIZE_1x1		0
#define		PL_SIZE_2x1		1
#define		PL_SIZE_2x2		3

#define		NBG0ON			(1<<0)
#define		NBG1ON			(1<<1)

#define		BM_512x256		0x02
#define		BM_512x512		0x06
#define		BM_1024x256		0x0a
#define		BM_1024x512		0x0e

extern void    slCurColor(Uint16) ;
extern	PerDigital*	Smpc_Peripheral;
extern	Uint8		Per_Connect1, Per_Connect2;
extern  void    slPlaneNbg1(Uint16) ;
extern  void   slUnitMatrix(MATRIX) ;
extern  Bool   slDispSprite(FIXED *, SPR_ATTR *attr, ANGLE) ;
extern  void    slScrPosNbg1(FIXED x,FIXED y) ;
extern  void    slZoomNbg1(FIXED x,FIXED y) ;
extern void    slDMACopy(void *, void *, Uint32) ;
extern  void    slBack1ColSet(void *, Uint16) ;
extern  void    slCharNbg0(Uint16 type,Uint16 size) ;
extern  void    slCharNbg1(Uint16 type,Uint16 size) ;
extern  void    slTVOn(void) ;
extern  void    slPageNbg1(void *,void *,Uint16) ;
extern  void    slMapNbg1(void *,void *,void *,void *) ;
extern void    slPrint(char *, void *) ;
extern  void    slBitMapNbg1(Uint16, Uint16, void *) ;
extern  void    slTVOff(void) ;
extern  Bool    slScrAutoDisp(Uint32) ;
extern  void   slInitSystem(Uint16, TEXTURE *, Sint8) ;
extern  void   slSynch(void) ;
extern  void    slPriority(Sint16, Uint16) ;
extern void   *slLocate(Uint16, Uint16) ;
#define		scnNBG0			1
#define		scnNBG1			0

extern  void   slLookAt(FIXED *camera, FIXED *target, ANGLE) ;
extern  void   slLight(VECTOR) ;
extern  Bool   slPushMatrix(void) ;
extern  Bool   slPopMatrix(void) ;
extern  void   slRotX(ANGLE) ;
extern  void   slRotY(ANGLE) ;
extern  void   slRotZ(ANGLE) ;
extern  void   slScale(FIXED, FIXED, FIXED) ;
extern  Bool   slPutPolygon(PDATA *) ;
extern  Bool   slWindow(Sint16, Sint16, Sint16, Sint16, Sint16, Sint16, Sint16) ;
extern  void   slPerspective(ANGLE) ;
extern  void   slTranslate(FIXED, FIXED, FIXED) ;
extern  void   slZdspLevel(Uint16) ;

extern	Bool	slRequestCommand(Uint8, Uint8);

#define CDC_POS_PTYPE(pos)          ((pos)->ptype)
#define CDC_POS_FAD(pos)            ((pos)->pbody.fad)
#define CDC_POS_TNO(pos)            ((pos)->pbody.trkidx.tno)
#define CDC_POS_IDX(pos)            ((pos)->pbody.trkidx.idx)

#define CDC_PLY_START(ply)          ((ply)->start)
#define CDC_PLY_END(ply)            ((ply)->end)
#define CDC_PLY_PMODE(ply)          ((ply)->pmode)

#define CDC_PLY_STYPE(ply)          CDC_POS_PTYPE(&CDC_PLY_START(ply))
#define CDC_PLY_SFAD(ply)           CDC_POS_FAD(&CDC_PLY_START(ply))
#define CDC_PLY_STNO(ply)           CDC_POS_TNO(&CDC_PLY_START(ply))
#define CDC_PLY_SIDX(ply)           CDC_POS_IDX(&CDC_PLY_START(ply))

#define CDC_PLY_ETYPE(ply)          CDC_POS_PTYPE(&CDC_PLY_END(ply))
#define CDC_PLY_EFAS(ply)           CDC_POS_FAD(&CDC_PLY_END(ply))
#define CDC_PLY_ETNO(ply)           CDC_POS_TNO(&CDC_PLY_END(ply))
#define CDC_PLY_EIDX(ply)           CDC_POS_IDX(&CDC_PLY_END(ply))

#define CDC_SM_EOR      0x01    /* R[hŌ̃ZN^ */
#define CDC_SM_VIDEO    0x02    /* rfIZN^ */
#define CDC_SM_AUDIO    0x04    /* I[fBIZN^ */
#define CDC_SM_DATA     0x08    /* f[^ZN^ */
#define CDC_SM_TRIG     0x10    /* gKnm */
#define CDC_SM_FORM     0x20    /* tH[rbgi1:Form2,  0:Form1j*/
#define CDC_SM_RT       0x40    /* A^CZN^ */
#define CDC_SM_EOF      0x80    /* t@CŌ̃ZN^ */

#define CDC_PM_DFL          0x00    /* Đ[h̏ȗl */

/* G[R[h */
#define GFS_ERR_OK              0       /* I                         */
#define GFS_ERR_CDRD            (-1)    /* CD[hG[                   */
#define GFS_ERR_CDNODISC        (-2)    /* CDZbgĂȂ           */
#define GFS_ERR_CDROM           (-3)    /* fBXNCD-ROMłȂ           */
#define GFS_ERR_DIRTBL          (-4)    /* fBNgǗe[us   */
#define GFS_ERR_OPENMAX         (-5)    /* őI[v̒ls         */
#define GFS_ERR_DIR             (-6)    /* wt@C̓fBNgłȂ */
#define GFS_ERR_CDBFS           (-7)    /* CDubNt@CVXe     */

#define GFS_ERR_NONAME          (-8)    /* t@CȂ             */
#define GFS_ERR_NEXIST          (-9)    /* w肳ꂽt@C݂͑Ȃ   */
#define GFS_ERR_FID             (-10)   /* sȃt@Cʎq             */
#define GFS_ERR_HNDL            (-11)   /* t@Cnhs           */
#define GFS_ERR_SEEK            (-12)   /* V[Nʒus                 */
#define GFS_ERR_ORG             (-13)   /* ʒls                   */
#define GFS_ERR_NUM             (-14)   /* oCg                     */
#define GFS_ERR_OFS             (-15)   /* ItZbgs                 */
#define GFS_ERR_FBUSY           (-16)   /* wt@C̏cĂ   */
#define GFS_ERR_PARA            (-17)   /* p[^s                 */
#define GFS_ERR_BUSY            (-18)   /* Cu֐s             */
#define GFS_ERR_NOHNDL          (-19)   /* t@Cnhɋ󂫂Ȃ     */
#define GFS_ERR_PUINUSE         (-20)   /* sbNAbv쒆               */
#define GFS_ERR_ALIGN           (-21)   /* Ɨ̈悪4byteEɂȂ        */
#define GFS_ERR_TMOUT           (-22)   /* ^CAEg                     */
#define GFS_ERR_CDOPEN          (-23)   /* gCJĂ               */
#define GFS_ERR_BFUL            (-24)   /* obt@tœǂݍݒ~       */
#define GFS_ERR_FATAL           (-25)   /* CDFATAL                    */


/* Xe[^X */
enum CdcStatus
{
    /* Xe[^XR[hibchCuԁj */
    CDC_ST_BUSY     = 0x00,     /* ԑJڒ */
    CDC_ST_PAUSE    = 0x01,     /* |[Yiꎞ~j */
    CDC_ST_STANDBY  = 0x02,     /* X^oCihCu~ԁj */
    CDC_ST_PLAY     = 0x03,     /* bcĐ */
    CDC_ST_SEEK     = 0x04,     /* V[N */
    CDC_ST_SCAN     = 0x05,     /* XLĐ */
    CDC_ST_OPEN     = 0x06,     /* gCJĂ */
    CDC_ST_NODISC   = 0x07,     /* fBXNȂ */
    CDC_ST_RETRY    = 0x08,     /* [hgC */
    CDC_ST_ERROR    = 0x09,     /* [hf[^G[ */
    CDC_ST_FATAL    = 0x0a,     /* vIG[ */

    /* ̑ */
    CDC_ST_PERI     = 0x20,     /* X|X */
    CDC_ST_TRNS     = 0x40,     /* f[^]v */
    CDC_ST_WAIT     = 0x80,     /* WAIT */
    CDC_ST_REJECT   = 0xff      /* REJECT */
};

/* ][h(GFS_SetTmode) */
enum GfsTransMode
{
    GFS_TMODE_SCU = 0,                  /* rbtɂcl`]    */
    GFS_TMODE_SDMA0,                    /* cl`TCNX`[]   cn=0 */
    GFS_TMODE_SDMA1,                    /*                              cn=1 */
    GFS_TMODE_CPU,                      /* \tgEFA] */
    GFS_TMODE_STM,                      /* Xg[p] */
    GFS_TMODE_END
};


enum CdcPosType
{
    CDC_PTYPE_DFL,          /* ȗl̎w */
    CDC_PTYPE_FAD,          /* t[AhXw */
    CDC_PTYPE_TNO,          /* gbN^CfbNXw */
    CDC_PTYPE_NOCHG,        /* ύX̎wiݒlύXȂj */

    CDC_PTYPE_END
};

/* bcʒup[^ */
typedef struct
{
    Sint32 ptype;           /* ʒu^Cviʒup[^̎ނ̎wj*/
    union
    {
        Sint32 fad;         /* t[AhXAZN^ */
        struct
        {
            Uint8 tno;      /* gbNԍ */
            Uint8 idx;      /* CfbNXԍ */
        } trkidx;
    } pbody;
} CdcPos;


/* bcĐp[^ */
typedef struct
{
    CdcPos  start;          /* Jnʒu */
    CdcPos  end;            /* Iʒu */
    Uint8   pmode;          /* Đ[hi߯߈ړAJԂ񐔁j*/
} CdcPly;


extern  void   slInitSound(Uint8 *, Uint32, Uint8 *, Uint32) ;
extern  Bool   slCDDAOn(Uint8, Uint8, Sint8, Sint8) ;
extern  Sint8  slPCMOn(PCM *, void *, Uint32) ;
extern  Bool   slPCMOff(PCM *) ;
extern  Sint8  slSndPCMNum() ;
extern  void   slSndFlush() ;
extern  Bool   slPCMStat(PCM *) ;
extern  Bool   slSndVolume(Uint8) ;

Sint32  CDC_CdPlay(CdcPly *ply);
Sint32  CDC_CdSeek(CdcPos *pos);
Sint32  CDC_CdInit(Sint32 iflag, Sint32 stnby, Sint32 ecc, Sint32 retry);

/* t@C */
typedef struct
{
    Sint32  fad;            /* t@C擪t[AhX */
    Sint32  size;           /* t@CTCYioCgj */
    Uint8   unit;           /* t@CjbgTCY */
    Uint8   gap;            /* MbvTCY */
    Uint8   fn;             /* t@Cԍ */
    Uint8   atr;            /* t@CAgr[g */
} CdcFile;

/* Tuwb_ */
typedef struct
{
    Uint8   fn;             /* t@Cԍ */
    Uint8   cn;             /* `lԍ */
    Uint8   smmsk;          /* Tu[h̃}XNp^[ */
    Uint8   smval;          /* Tu[h̔rl */
    Uint8   cimsk;          /* R[fBÕ}XNp^[ */
    Uint8   cival;          /* R[fBO̔rl */
} CdcSubh;


typedef Sint32 (*GfsTransFunc)(void *obj, Sint32 nsct);

/* t@C */
typedef struct
{
    Sint32      fid;                    /* t@Cʎq */
    CdcFile     finfo;
    Sint32      sctsz;                  /* ZN^ */
    Sint32      nsct;                   /* ZN^ */
    Sint32      lstrm;                  /* ŏIZN^̖f[^   */
} GfsFinfo;


/* CDobt@̎Ǘ */
typedef struct
{
    Sint32      bufno;                  /* obt@ԍ */
    Sint32      sctsz;                  /* bcobt@̃ZN^TCY   */
    Sint32      flt;                    /* iԍ */
    CdcSubh     subh;                   /* Tuwb_ */
    Sint32      fmode;                  /* i胂[h */
    Sint32      puid;                   /* 擾sbNAbṽ[UID */
    Sint32      filepos;                /* 擪f[^̃t@C̈ʒu */
    Sint32      sctpos;                 /* ]ʒu */
    /* Đ͈ */
    Sint32      sfad;                   /* JnFAD */
    Sint32      efad;                   /* IFAD */
} GfsCdRsrc;


/* SCSIt@C̉zCDobt@Ǘ */
typedef struct
{
    Sint32      fid;                    /* SCSIt@Cʎq   */
    Sint32      filepos;                /* 擪f[^̃t@C̈ʒu */
    Sint32      sctpos;                 /* obt@̃ZN^ʒu */
    Sint32      sctnum;                 /* obt@̃ZN^ */
} GfsScsiRsrc;


/* t@C̉zCDobt@Ǘ */
typedef struct
{
    void        *data;                  /* f[^̈           */
    Sint32      filepos;                /* 擪f[^̃t@C̈ʒu */
    Sint32      sctpos;                 /* obt@̃ZN^ʒu */
    Sint32      sctnum;                 /* obt@̃ZN^ */
} GfsMemRsrc;


/* ǂݍ݌Ǘ */
typedef struct
{
    /* ǂݍ݌Ǘ */
    Sint32      ftype;                  /* t@C         */
    union
    {
        GfsCdRsrc       cd;             /* CD̎             */
        GfsScsiRsrc     scsi;           /* SCSIt@C̎   */
        GfsMemRsrc      mem;            /* t@C̎ */
    } rsrc;
} GfsDtsrc;


/* CD̓ǂݍ݂Ǘ */
typedef struct
{
    GfsFinfo    finfo;                  /* t@C         */
    GfsDtsrc    dtsrc;                  /* ǂݍ݌           */
    Sint32      gmode;                  /* o[h       */
    Sint32      stat;                   /* s             */
    /* flow inǗ */
    Sint32      sct;                    /* ǂݍ݃ZN^     */
    Sint32      sctcnt;                 /* ǂݍ݃JE^     */
    Sint32      sctmax;                 /* ǂݍݍőZN^ */
} GfsFlow;


/* f[^pbN\ */
typedef struct
{
    void        *data;                  /* f[^̈           */
    Sint32      adlt;                   /* AhX̑     */
    Sint32      len;                    /* ]oCg         */
    Sint32      nsct;                   /* ]ZN^         */
    Bool        use;                    /* gptO           */
} GfsDataPack;


typedef GfsDataPack *GfdpHn;

/* ]Ǘ */
/* CDobt@̓]Ǘ */
typedef struct
{
    void        *buf;                   /* ]AhX */
    Sint32      size;                   /* f[^̈̃TCY */
    Sint32      wp;                     /* ݃ItZbg */
    /* ]Ǘ */
    GfdpHn      dps;                    /* ]̃f[^pbN */
    GfdpHn      dpd;                    /* ]悩̃f[^pbN */
    Sint32      tsctmax;                /* P̓]̍őZN^ */
    Sint32      tsct;                   /* ]ڕWZN^ */
    Sint32      tsctcnt;                /* ݂܂œ]ZN^ */
    Sint32      tbytcnt;                /* ZN^̓]oCg */
    /* ]֐ */
    void        *obj;                   /* ]֐ւ̑P */
    GfsTransFunc tfunc;                 /* ]֐ */
    Sint32      unit;                   /* ]P */
    Bool        active;                 /* 쒆tO */
    Sint32      stat;                   /*  */
    Sint32      mode;                   /* ][h */
} GfsTrans;


typedef GfsTrans *GftrHn;


/* I[vt@CǗ */
typedef struct
{
    Bool        used;                   /* ̍\̂gpǂ */
    Sint32      amode;                  /* ANZX[h */
    Sint32      astat;                  /* ANZX */
    GfsFlow     flow;
    GfsTrans    trans;
} GfsFile;

#define GFS_FNAME_LEN   12              /* t@C̒                 */



/* fBNgR[h\(t@CȂ)   */
typedef struct
{
    CdcFile     dirrec;
} GfsDirId;


/* fBNgR[h\(t@C)   */
typedef struct
{
    CdcFile     dirrec;
    Sint8       fname[GFS_FNAME_LEN];   /* t@C */
} GfsDirName;


/* fBNgǗ\ */
typedef struct
{
    Sint32      type;                   /*  */
    Sint32      ndir;                   /* ővf */
    union
    {
        GfsDirId *dir_i;                /* t@CȂfBNg */
        GfsDirName *dir_n;              /* t@CfBNg */
    } dir;
} GfsDirTbl;


/* t@Cnh */
typedef GfsFile *GfsHn;

#define GFS_FTYPE_NR    3               /* t@Cʐ */
#define GFS_SCTBUF_SIZ  2048            /* ZN^obt@̑傫 */
#define GFS_OPEN_MAX    24              /* őI[vt@C */
#define GFS_FCONQ_MAX   24              /* ڑR}hL[̍ő咷 */

/* G[֐ */
typedef void (*GfsErrFunc)(void *obj, Sint32 ec);

/* G[ */
typedef struct
{
    GfsErrFunc  func;                   /* G[̌Ăяo֐   */
    void        *obj;                   /* Ăяo֐ɓn   */
    Sint32      code;                   /* G[R[h                 */
} GfsErrStat;

#define GFS_CDBBUF_NR   24              /* CDubN̋搔 */
#define GFS_SELQ_MAX    24              /* iݒR}hL[̍ő咷 */

/* fBNg(GFS_LoadDir, GFS_SetDir)     */
enum GfsDirType
{
    GFS_DIR_ID          = 0,            /* t@CɂANZXs */
    GFS_DIR_NAME                        /* t@CɂANZX   */
};

enum GfsServerStatus
{
    GFS_SVR_COMPLETED = 0,              /* St@C̃ANZXI     */
    GFS_SVR_BUSY,                       /* t@CANZX           */
    GFS_SVR_CDPAUSE,                    /* bcobt@ẗ׈ꎞ~ */
    GFS_SVR_ERROR                       /* G[ */
};



/* ڑR}hL[̗vf(CDubNǗ\, GfsCdbMng̃o) */
typedef struct
{
    Sint32 flt;                         /* ݒi */
    Sint32 buf;                         /* ^o͐ڑobt@ */
    Sint32 flnout;                      /* Uo͐ڑi(̒lgp) */
} GfcdFconQu;


/* bcXe[^XiXe[^X{bc|[gj */
typedef struct
{
    Uint8   status;         /* Xe[^X */
    struct                  /* bc|[g */
    {
        Uint8   flgrep;     /* bctOƃs[g */
        Uint8   ctladr;     /* CONTROL/ADRoCg */
        Uint8   tno;        /* gbNԍ */
        Uint8   idx;        /* CfbNXԍ */
        Sint32  fad;        /* t[AhX */
    } report;
} CdcStat;

/* iݒR}hL[̗vf(CDubNǗ\, GfsCdbMng̃o) */
typedef struct
{
    Uint8 flt;                          /* ݒiԍ */
    Uint8 fmode;                        /* i胂[h */
    CdcSubh subh;                       /* Tuwb_ */
    Sint32 fad;                         /* JnFAD */
    Sint32 snum;                        /* FADZN^ */
} GfcdSelQu;


/* CDubNǗ\(Ǘe[u, GfsMng̃o) */
typedef struct
{
    /* Ǘ */
    Sint8 use_buf[GFS_CDBBUF_NR];       /* obt@gp */
    Sint8 use_filt[GFS_CDBBUF_NR];      /* igp */
    Bool use_pu;                        /* sbNAbvgp */
    Sint32 tr_bufno;                    /* f[^]̃obt@   */
    Sint32 puid;                        /* sbNAbv̏LID */
    Sint32 timer;                       /* ^CAEgJE^ */
    CdcStat stat;                       /* CDubN̏ */
    void (*func)(void *);               /* CSCTnh */
    void *obj;                          /* CSCTnḧ */
    /* GFCD_SetFilt^XN */
    struct
    {
        Sint32 len;                     /* iݒR}hL[̒ */
        Sint32 stat;                    /* R}hL[擪̏ */
        GfcdSelQu selq[GFS_SELQ_MAX];   /* iݒR}hL[ */
    } tsk_setflt;
    /* GFCD_SetFiltCon^XN */
    struct
    {
        Sint32 len;                     /* ڑR}hL[̒ */
        Sint32 stat;                    /* ^XNItO */
        GfcdFconQu fconq[GFS_FCONQ_MAX]; /* ڑR}hL[ */
    } tsk_fltcon;
    /* GFCD_SetCon^XN */
    struct
    {
        Sint32 stat;                    /* ^XNItO */
        Sint32 flt;                     /* CDڑi */
    } tsk_setcon;
    /* GFCD_GetLenData^XN */
    struct
    {
        Sint32 stat;                    /* ^XNItO */
        Sint32 bufno;                   /* Ώۋ */
        Sint32 spos;                    /* 擪ZN^ʒu */
        Sint32 usct;                    /* vZN^ */
        Sint32 cnt;                     /* ^XN̎s */
        Sint32 *nsct;                   /* ZN^i[ */
        Sint32 *nbyte;                  /* oCgi[ */
    } tsk_getlen;
    /* GFCD_ReqData^XN */
    struct
    {
        Sint32 stat;                    /* ^XNItO */
        Sint32 bufno;                   /* Ώۋ */
        Sint32 sctpos;                  /* ZN^ʒu */
        Sint32 nsct;                    /* vZN^ */
    } tsk_reqdat;
    /* GFCD_DelSctData^XN */
    struct
    {
        Sint32 stat;                    /* ^XNItO */
        Sint32 bufno;                   /* Ώۋ */
        Sint32 sctpos;                  /* 폜JnZN^ʒu */
        Sint32 nsct;                    /* 폜ZN^ */
    } tsk_delsct;
    /* GFCD_MoveSctData^XN */
    struct
    {
        Sint32 stat;                    /* ^XNItO */
        Sint32 dst;                     /* ړ */
        Sint32 src;                     /* ړ */
        Sint32 spos;                    /* ړJnZN^ʒu */
        Sint32 snum;                    /* ړZN^ */
        Sint32 fmode;                   /* ړZN^̍i胂[hۑ */
    } tsk_movsct;
    /* GFCD_ChgDir^XN */
    struct
    {
        Sint32 stat;                    /* ^XNItO */
        Sint16 fid;                     /* ݒt@Cʎq */
        Sint16 work;                    /* ƃobt@ */
        Sint32 *ndir;                   /* ێfBNg */
    } tsk_chgdir;
} GfsCdbMng;


/* ANZXT[oǗ\(Ǘe[u, GfsMng̃o) */
typedef struct
{
    GfsHn   access_file[GFS_OPEN_MAX];  /* ANZX[hwσt@C */
    Sint32  nfile;                      /* o^t@C               */
} GfsSvr;

/* fBNgǗ\(Ǘe[u, GfsMng̃o) */
typedef struct
{
    GfsDirTbl   dirtbl;                 /* fBNgǗ */
    Sint32      nfile;                  /* t@C */
} GfsDirMng;

/* t@Cp֐(Ǘe[u, GfsMng̃o) */
typedef struct
{
    Sint32 (*flowin)(GfsFlow *);        /* \[Xobt@ǂݍ݊֐   */
    void (*stopin)(GfsFlow *, Bool);    /* ǂݍݒ~֐             */
    Sint32 (*seek)(GfsFlow *, Sint32);  /* ANZX|C^ݒ֐     */
    Sint32 (*tell)(GfsFlow *);          /* ANZX|C^擾֐     */
} GfsFileFunc;


/* Ǘe[u */
typedef struct
{
    Sint32      openmax;                /* I[vt@C̍ő吔 */
    GfsFileFunc functbl[GFS_FTYPE_NR];  /* t@Cp֐ */
    GfsSvr      svr;                    /* ANZXT[o */
    GfsDirMng   curdir;                 /* JgfBNg */
    GfsHn       pickup;                 /* sbNAbv䒆t@C */
    Sint32      sfad;                   /* Đ͈:JnFAD */
    Sint32      efad;                   /* Đ͈:IFAD+1 */
    GfsHn       trans;                  /* f[^]t@C */
    GfsErrStat  error;                  /* G[ */
    Uint32      flags;                  /* foCXڑȂ */
    Sint32      timer;                  /* ^CAEgJE^ */
    GfsCdbMng   cdb;                    /* CDubNǗ\ */
    GfsDataPack srcpk;                  /* ]f[^pbN */
    GfsDataPack dstpk;                  /* ]f[^pbN */
    Uint8       sect_buf[GFS_SCTBUF_SIZ]; /* PZN^̓ǂݍݗpobt@ */
    GfsFile     file[1];                /* Snh̔ziϒj */
} GfsMng;

#define GFS_WORK_SIZE(open_max) \
            (sizeof(GfsMng) + ((open_max) - 1) * sizeof(GfsFile))
#define GFS_DIRTBL_TYPE(dirtbl)         ((dirtbl)->type)
#define GFS_DIRTBL_DIRNAME(dirtbl)      ((dirtbl)->dir.dir_n)
#define GFS_DIRTBL_NDIR(dirtbl)         ((dirtbl)->ndir)

/* t@CVXȅ */
Sint32 GFS_Init(Sint32 open_max, void *work, GfsDirTbl *dirtbl);
/* A^ǂݍ */
Sint32 GFS_NwFread(GfsHn gfs, Sint32 nsct, void *buf, Sint32 bsize);
/* t@CPʂł̃ANZX̎s */
Sint32 GFS_NwExecOne(GfsHn gfs);
/* A^ǂݍ */
Sint32 GFS_Fread(GfsHn gfs, Sint32 nsct, void *buf, Sint32 bsize);
/* ANZXԂ̎擾 */
void GFS_NwGetStat(GfsHn gfs, Sint32 *amode, Sint32 *ndata);
/* t@Cnh̊ */
GfsHn GFS_Open(Sint32 fid);
/* t@Cnh̊ĉ */
void GFS_Close(GfsHn gfs);
void GFS_GetFileSize(GfsHn gfs, Sint32 *sctsz, Sint32 *nsct, Sint32 *lstsz);
Sint32 GFS_NwCdRead(GfsHn gfs, Sint32 nsct);
Sint32 GFS_SetTransPara(GfsHn gfs, Sint32 tsize);

Sint32 GFS_LoadDir(Sint32 fid, GfsDirTbl *dirtbl);
Sint32 GFS_SetDir(GfsDirTbl *dirtbl);
Sint32 GFS_NameToId(Sint8 *fname);
Sint32 GFS_Load(Sint32 fid, Sint32 ofs, void *buf, Sint32 bsize);


typedef struct  			/* qsb				*/
{
    Uint16	year;			/* N				*/
    Uint8	month;			/* jE				*/
    Uint8	date;			/* 					*/
    Uint8	hour;			/* 					*/
    Uint8	minute;			/* 					*/
    Uint8	second;			/* b					*/
    Uint8	dummy;			/* _~[				*/
} SmpcDateTime;


typedef struct  			/* rlobXe[^X			*/
{
    Uint8	cond;			/* ԃXe[^X			*/
    Uint8	dummy1;			/* _~[P				*/
    Uint16	dummy2;			/* _~[Q				*/
    SmpcDateTime	rtc;		/* qsb				*/
    Uint8	ctg;			/* J[gbWR[h			*/
    Uint8	area;			/* GAR[h				*/
    Uint16	system;			/* VXeXe[^X			*/
    Uint32	smem;			/* rlobێf[^		*/
} SmpcStatus;

enum SmpcLanguage  			/* rlobԍ		*/
{
    SMPC_ENGLISH,			/* (00) p				*/
    SMPC_DEUTSCH,			/* (01) hCc			*/
    SMPC_FRANCAIS,			/* (02) tX			*/
    SMPC_ESPANOL,			/* (03) XyC			*/
    SMPC_ITALIANO,			/* (04) C^A			*/
    SMPC_JAPAN			/* (05) {				*/
};

extern  void   slIntFunction(void (*func)()) ;
extern	Uint8	slGetLanguage(void);

extern	SmpcStatus*	Smpc_Status;
#define	slGetStatus()			slRequestCommand(SMPC_GETSTS, SMPC_NO_WAIT)


#define	    COL_256	(2+0)		/* J[oNQTUF[h */
#define	    COL_32K	(2-1)		/* qfaRQjF[h */

#define	    SPR_ATTRIBUTE(t,c,g,a,d)	{t,(a)|(((d)>>24)&0xc0),c,g,(d)&0x0f3f}
#define	    FUNC_Sprite		1
#define	    CL256Bnk		(4 << 3)	/* J[oNQTUF[h */

#define	    SpriteVRAM		0x25c00000

#define	CGADDRESS	0x10000
#define	AdjCG(cga,hs,vs,col)		((cga) + (((((hs)*(vs)*4)>>(col))+0x1f) &0x7ffe0))
#define	TEXTBL(hs,vs,cga)		{hs , vs , (cga)>>3 , ((hs)&0x1f8)<<5|(vs)}
#define	PICTBL(texno,cmode,pcsrc)	{(Uint16)(texno),(Uint16)(cmode),(void *)(pcsrc)}

/*
#include <SGL_CPK.H>
*/

#else /* JO_COMPILE_USING_SGL */

#include <sgl.h>
#include <sl_def.h>
#include <SEGA_CDC.H>
#include <SEGA_GFS.H>

#endif

/*
#include <SEGA_SYS.H>
*/
void SYS_Exit(Sint32 code);

#endif /* !__JO_SGL_PROTOTYPES_H__ */

/*
** END OF FILE
*/
